unit UFormCpuState;

{$mode delphi}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls, StdCtrls,
  ExtCtrls, UMachine, UCpu;

type

  { TFormCpuState }

  TFormCpuState = class(TForm)
    LabelTicks: TLabel;
    LabelDataMode: TLabel;
    LabelAddrMode: TLabel;
    ListViewRegisters: TListView;
    Timer1: TTimer;
    procedure ListViewRegistersData(Sender: TObject; Item: TListItem);
    procedure Timer1Timer(Sender: TObject);
  private
  public
    Machine: TMachine;
    procedure Reload;
  end;

var
  FormCpuState: TFormCpuState;

implementation

{$R *.lfm}

{ TFormCpuState }

procedure TFormCpuState.Reload;
begin
  ListViewRegisters.Items.Count := Length(Machine.Cpu.Registers);
  ListViewRegisters.Refresh;
  LabelTicks.Caption := 'Ticks: ' + IntToStr(Machine.Cpu.Ticks);
  LabelDataMode.Caption := 'Data mode: ' + BitWidthText[Machine.Cpu.DataSize];
  LabelAddrMode.Caption := 'Address mode: ' + BitWidthText[Machine.Cpu.AddrSize];
end;

procedure TFormCpuState.ListViewRegistersData(Sender: TObject; Item: TListItem);
begin
  if Item.Index < Length(Machine.Cpu.Registers) + 2 then begin
    if Item.Index = 0 then begin
      Item.Caption := 'IP';
      Item.SubItems.Add(IntToHex(Machine.Cpu.IP, 16));
    end else
    if Item.Index = 1 then begin
      Item.Caption := 'SP';
      Item.SubItems.Add(IntToHex(Machine.Cpu.SP, 16));
    end else begin
      Item.Caption := 'R' + IntToStr(Item.Index - 2);
      Item.SubItems.Add(IntToHex(Machine.Cpu.Registers[Item.Index - 2].D, 16));
    end;
  end;
end;

procedure TFormCpuState.Timer1Timer(Sender: TObject);
begin
  if Visible then Reload;
end;

end.

