unit UFormDisassembler;

{$mode delphi}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls,
  UInstructionWriter;

type

  { TFormDisassembler }

  TFormDisassembler = class(TForm)
    ListView1: TListView;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListView1Data(Sender: TObject; Item: TListItem);
  private

  public
    Disassembler: TDisassembler;
    procedure Reload;
  end;

var
  FormDisassembler: TFormDisassembler;

implementation

{$R *.lfm}

{ TFormDisassembler }

procedure TFormDisassembler.FormCreate(Sender: TObject);
begin
  Disassembler := TDisassembler.Create;
end;

procedure TFormDisassembler.FormDestroy(Sender: TObject);
begin
  Disassembler.Free;
end;

procedure TFormDisassembler.ListView1Data(Sender: TObject; Item: TListItem);
begin
  if Item.Index < Disassembler.Output.Count then
  with TDisassemblerLine(Disassembler.Output[Item.Index]) do begin
    Item.Caption := IntToHex(Address, 8);
    Item.SubItems.Add(Opcode);
    Item.SubItems.Add(Instruction);
  end;
end;

procedure TFormDisassembler.Reload;
begin
  ListView1.Items.Count := Disassembler.Output.Count;
  ListView1.Refresh;
end;

end.

