unit UFormMemory;

{$mode delphi}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls, ExtCtrls,
  UMachine;

type

  { TFormMemory }

  TFormMemory = class(TForm)
    ListViewMemory: TListView;
    Timer1: TTimer;
    procedure ListViewMemoryData(Sender: TObject; Item: TListItem);
    procedure Timer1Timer(Sender: TObject);
  private
  public
    Machine: TMachine;
    procedure Reload;
  end;

var
  FormMemory: TFormMemory;

const
  ItemsPerLine = 16;


implementation

{$R *.lfm}

procedure TFormMemory.Reload;
begin
  ListViewMemory.Items.Count := Machine.MemorySize div ItemsPerLine;
  ListViewMemory.Refresh;
end;

procedure TFormMemory.ListViewMemoryData(Sender: TObject; Item: TListItem);
var
  Line: string;
  I: Integer;
  Text: string;
  One: Byte;
begin
  if Item.Index < Machine.MemorySize div ItemsPerLine then begin
    Line := '';
    Text := '';
    for I := 0 to ItemsPerLine - 1 do begin
      One := PByte(Machine.Memory + Item.Index * ItemsPerLine + I)^;
      Line := Line + IntToHex(One, 2) + ' ';
      if One >= 32 then Text := Text + Char(One)
        else Text := Text + ' ';
    end;
    Item.Caption := IntToHex(Item.Index * ItemsPerLine, 8);
    Item.SubItems.Add(Line);
    Item.SubItems.Add(Text);
  end;
end;

procedure TFormMemory.Timer1Timer(Sender: TObject);
begin
  if Visible then Reload;
end;


end.

