unit UMemory;

{$mode delphi}

interface

uses
  Classes, SysUtils;

type

  { TMemory }

  TMemory = class
  private
    FData: Pointer;
    FOwner: Boolean;
    FSize: Integer;
    procedure SetData(AValue: Pointer);
    procedure SetSize(AValue: Integer);
  public
    property Owner: Boolean read FOwner write FOwner;
    property Data: Pointer read FData write SetData;
    property Size: Integer read FSize write SetSize;
  end;

  { TMemoryStream }

  TMemoryPos = class(TMemory)
    Position: Pointer;
    function ReadByte: Byte;
    function ReadWord: Word;
    procedure WriteByte(Value: Byte);
    procedure WriteWord(Value: Word);
  end;

implementation

{ TMemoryStream }

function TMemoryPos.ReadByte: Byte;
begin
  Result := PByte(Position)^;
  Inc(Position, SizeOf(Byte));
end;

function TMemoryPos.ReadWord: Word;
begin
  Result := PWord(Position)^;
  Inc(Position, SizeOf(Word));
end;

procedure TMemoryPos.WriteByte(Value: Byte);
begin
  PByte(Position)^ := Value;
  Inc(Position, SizeOf(Byte));
end;

procedure TMemoryPos.WriteWord(Value: Word);
begin
  PWord(Position)^ := Value;
  Inc(Position, SizeOf(Word));
end;

{ TMemory }

procedure TMemory.SetSize(AValue: Integer);
begin
  if FSize = AValue then Exit;
  FSize := AValue;
  FData := ReAllocMem(FData, FSize);
end;

procedure TMemory.SetData(AValue: Pointer);
begin
  if FData = AValue then Exit;
  if FOwner then FreeMem(FData);
  FData := AValue;
  if Assigned(FData) then FSize := MemSize(FData)
    else FSize := 0;
end;

end.

